ExpressMail = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceHook-2.1")

ExpressMail.date = string.sub("$Date: 2006-12-07 05:36:28 -0500 (Thu, 07 Dec 2006) $", 8, 17)

function ExpressMail:OnEnable()
	self:SecureHook("InboxFrame_OnClick")
	self:SecureHook(GameTooltip, "SetInboxItem")
end

function ExpressMail:SetInboxItem(tooltip, index)
	tooltip:AddLine("Shift - Take Item")

	local _, _, _, _, _, _, _, _, _, wasReturned, _, canReply = GetInboxHeaderInfo(index)
	if not wasReturned and canReply then tooltip:AddLine("Ctrl - Return Item") end
end

function ExpressMail:InboxFrame_OnClick(index)
	if IsShiftKeyDown() then return self:TakeMoney(index) or self:TakeItem(index)
	elseif IsControlKeyDown() then return self:ReturnMail(index)
	end
end

function ExpressMail:ReturnMail(index)
	local _, _, _, _, _, _, _, _, _, wasReturned, _, canReply = GetInboxHeaderInfo(index)
	if wasReturned or not canReply then return end

	ReturnInboxItem(index)
	InboxFrame_Update()
	return true
end

function ExpressMail:DeleteMail(index, overrideTextOnly)
	local _, _, _, _, money, COD, _, hasItem = GetInboxHeaderInfo(index)
	local bodyText, _, isTakeable = GetInboxText(index)
	if money > 0 or COD > 0 or hasItem or isTakeable or (bodyText and not overrideTextOnly) then return end

	DeleteInboxItem(index)
	InboxFrame_Update()
	return true
end

function ExpressMail:TakeItem(index, confirmCOD)
	local _, _, _, _, _, COD, _, hasItem = GetInboxHeaderInfo(index)
	if not hasItem or (COD > 0 and not confirmCOD) then return end

	TakeInboxItem(index)
	InboxFrame_Update()
	return true
end

function ExpressMail:TakeMoney(index)
	local _, _, _, _, money = GetInboxHeaderInfo(index)
	if money == 0 then return end

	TakeInboxMoney(index)
	InboxFrame_Update()
	return true
end

function ExpressMail:TakeText(index)
	local _, _, _, _, _, _, _, _, _, _, text = GetInboxHeaderInfo(index)
	local _, _, isTakeable = GetInboxText(index)
	if not text or not isTakeable then return end

	TakeInboxTextItem(index)
	InboxFrame_Update()
	return true
end
